summaryrefslogtreecommitdiffstats
path: root/vendor/opener
diff options
context:
space:
mode:
Diffstat (limited to 'vendor/opener')
-rw-r--r--vendor/opener/.cargo-checksum.json1
-rw-r--r--vendor/opener/Cargo.toml41
-rwxr-xr-xvendor/opener/Drakefile.ts79
-rwxr-xr-xvendor/opener/LICENSE-APACHE1
-rwxr-xr-xvendor/opener/LICENSE-MIT1
-rwxr-xr-xvendor/opener/LICENSE-THIRD-PARTY1
-rw-r--r--vendor/opener/src/lib.rs224
-rw-r--r--vendor/opener/src/linux_and_more.rs108
-rw-r--r--vendor/opener/src/macos.rs15
-rw-r--r--vendor/opener/src/windows.rs41
-rwxr-xr-xvendor/opener/src/xdg-open1066
-rw-r--r--vendor/opener/tests/version-numbers.rs4
12 files changed, 1582 insertions, 0 deletions
diff --git a/vendor/opener/.cargo-checksum.json b/vendor/opener/.cargo-checksum.json
new file mode 100644
index 000000000..9f0ef06c4
--- /dev/null
+++ b/vendor/opener/.cargo-checksum.json
@@ -0,0 +1 @@
+{"files":{"Cargo.toml":"ee161809cf1f818ecb2952d86acfc4867224e9f6f1cf83a6828eee6316ad5271","Drakefile.ts":"e357716de020b86a99b96b0b345651f3b2654e77dcb5c7fa98edea4a2a374589","LICENSE-APACHE":"154397a08d0cb342110281129971868cd562542d0780b0d10722788cd11a1399","LICENSE-MIT":"72af89a828df52a9dcc42512ed64663b3b8d7961dd7a5586d44478eede82bc7a","LICENSE-THIRD-PARTY":"0a22326fd75448038b10861d0abb270d607348458c875e9e774fbf8d7d5bd052","src/lib.rs":"8981b76e1c5eae38418ac334c51993d9faf27775e7df800c680eb802883c41e2","src/linux_and_more.rs":"96912d2099ac0cad116160b9147d46c8c374f191796c2095a1c56519feed4909","src/macos.rs":"38e762e83064c2150a125b6e6c477640652f9dceeeadbeeda64d0edd4936cf01","src/windows.rs":"d0ed2e6ae1deb8ded4eb8cc9204a868290f390aa9078b7cd953b1dfbd2261c25","src/xdg-open":"a99799b070c39e9788d097f1057bdee688248c5f3df82353beebe90c561aeb75","tests/version-numbers.rs":"8069cb08b31531f8eb5e164089b1acbe7dc77e4ba87dcc0a3717205446847795"},"package":"4ea3ebcd72a54701f56345f16785a6d3ac2df7e986d273eb4395c0b01db17952"} \ No newline at end of file
diff --git a/vendor/opener/Cargo.toml b/vendor/opener/Cargo.toml
new file mode 100644
index 000000000..bbc220c45
--- /dev/null
+++ b/vendor/opener/Cargo.toml
@@ -0,0 +1,41 @@
+# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
+#
+# When uploading crates to the registry Cargo will automatically
+# "normalize" Cargo.toml files for maximal compatibility
+# with all versions of Cargo and also rewrite `path` dependencies
+# to registry (e.g., crates.io) dependencies
+#
+# If you believe there's an error in this file please file an
+# issue against the rust-lang/cargo repository. If you're
+# editing this file be aware that the upstream Cargo.toml
+# will likely look very different (and much more reasonable)
+
+[package]
+edition = "2018"
+name = "opener"
+version = "0.5.0"
+authors = ["Brian Bowman <seeker14491@gmail.com>"]
+description = "Open a file or link using the system default program."
+readme = "../README.md"
+keywords = ["open", "default", "launcher", "browser"]
+categories = ["os"]
+license = "MIT OR Apache-2.0"
+repository = "https://github.com/Seeker14491/opener"
+[dev-dependencies.version-sync]
+version = "0.9"
+[target."cfg(target_os = \"linux\")".dependencies.bstr]
+version = "0.2"
+[target."cfg(windows)".dependencies.winapi]
+version = "0.3"
+features = ["shellapi"]
+[badges.appveyor]
+branch = "master"
+repository = "Seeker14491/opener"
+service = "github"
+
+[badges.maintenance]
+status = "passively-maintained"
+
+[badges.travis-ci]
+branch = "master"
+repository = "Seeker14491/opener"
diff --git a/vendor/opener/Drakefile.ts b/vendor/opener/Drakefile.ts
new file mode 100755
index 000000000..476cb23d9
--- /dev/null
+++ b/vendor/opener/Drakefile.ts
@@ -0,0 +1,79 @@
+import {
+ abort,
+ desc,
+ env,
+ run,
+ sh,
+ shCapture,
+ task,
+} from "https://deno.land/x/drake@v1.5.0/mod.ts";
+
+const SHOULD_CARGO_PUBLISH = true;
+const SHOULD_PUSH_DOCS_TO_GITHUB_PAGES = false;
+
+desc("Release a new version of the crate");
+task("release", [], async () => {
+ const version = env("version");
+ if (version == null) {
+ abort("The version to release was not specified");
+ }
+ if (!isValidSemVer(version)) {
+ abort("The given version is not a valid SemVer string");
+ }
+
+ await sh("cargo test --all-features");
+ await sh("cargo fmt -- --check");
+ await sh("git diff HEAD --exit-code --name-only");
+
+ if (SHOULD_CARGO_PUBLISH) {
+ await sh("cargo publish --dry-run");
+ }
+
+ const tagName = `v${version}`;
+ await sh(`git tag -a ${tagName} -m "Release ${tagName}"`);
+ await sh("git push origin master");
+ await sh(`git push origin ${tagName}`);
+
+ if (SHOULD_CARGO_PUBLISH) {
+ await sh("cargo publish");
+ }
+
+ if (SHOULD_PUSH_DOCS_TO_GITHUB_PAGES) {
+ await run("upload-docs");
+ }
+});
+
+desc("Upload docs to GitHub Pages");
+task("upload-docs", [], async () => {
+ let origin_url;
+ {
+ const { code, output, error } = await shCapture(
+ "git remote get-url origin",
+ );
+ if (code == 0) {
+ origin_url = output.trim();
+ } else {
+ abort("Error getting origin's url from git");
+ }
+ }
+
+ await sh("cargo clean --doc");
+ await sh("cargo doc --no-deps");
+
+ {
+ const run = (command: string) => sh(command, { cwd: "target/doc" });
+
+ await run("git init");
+ await run("git add .");
+ await run('git commit -am "(doc upload)"');
+ await run(`git push -f ${origin_url} master:gh-pages`);
+ }
+});
+
+run();
+
+function isValidSemVer(s: string): boolean {
+ return s.match(
+ /^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(?:-((?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\.(?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?(?:\+([0-9a-zA-Z-]+(?:\.[0-9a-zA-Z-]+)*))?$/,
+ ) != null;
+}
diff --git a/vendor/opener/LICENSE-APACHE b/vendor/opener/LICENSE-APACHE
new file mode 100755
index 000000000..965b606f3
--- /dev/null
+++ b/vendor/opener/LICENSE-APACHE
@@ -0,0 +1 @@
+../LICENSE-APACHE \ No newline at end of file
diff --git a/vendor/opener/LICENSE-MIT b/vendor/opener/LICENSE-MIT
new file mode 100755
index 000000000..76219eb72
--- /dev/null
+++ b/vendor/opener/LICENSE-MIT
@@ -0,0 +1 @@
+../LICENSE-MIT \ No newline at end of file
diff --git a/vendor/opener/LICENSE-THIRD-PARTY b/vendor/opener/LICENSE-THIRD-PARTY
new file mode 100755
index 000000000..03ded5598
--- /dev/null
+++ b/vendor/opener/LICENSE-THIRD-PARTY
@@ -0,0 +1 @@
+../LICENSE-THIRD-PARTY \ No newline at end of file
diff --git a/vendor/opener/src/lib.rs b/vendor/opener/src/lib.rs
new file mode 100644
index 000000000..a84f9491a
--- /dev/null
+++ b/vendor/opener/src/lib.rs
@@ -0,0 +1,224 @@
+#![doc(html_root_url = "https://docs.rs/opener/0.5.0")]
+
+//! This crate provides the [`open`] function, which opens a file or link with the default program
+//! configured on the system:
+//!
+//! ```no_run
+//! # fn main() -> Result<(), ::opener::OpenError> {
+//! // open a website
+//! opener::open("https://www.rust-lang.org")?;
+//!
+//! // open a file
+//! opener::open("../Cargo.toml")?;
+//! # Ok(())
+//! # }
+//! ```
+//!
+//! An [`open_browser`] function is also provided, for when you intend on opening a file or link in a
+//! browser, specifically. This function works like the [`open`] function, but explicitly allows
+//! overriding the browser launched by setting the `$BROWSER` environment variable.
+
+#![warn(
+ rust_2018_idioms,
+ deprecated_in_future,
+ macro_use_extern_crate,
+ missing_debug_implementations,
+ unused_qualifications
+)]
+
+#[cfg(not(any(target_os = "windows", target_os = "macos")))]
+mod linux_and_more;
+#[cfg(target_os = "macos")]
+mod macos;
+#[cfg(target_os = "windows")]
+mod windows;
+
+#[cfg(not(any(target_os = "windows", target_os = "macos")))]
+use crate::linux_and_more as sys;
+#[cfg(target_os = "macos")]
+use crate::macos as sys;
+#[cfg(target_os = "windows")]
+use crate::windows as sys;
+
+use std::error::Error;
+use std::ffi::{OsStr, OsString};
+use std::fmt::{self, Display, Formatter};
+use std::process::{Command, ExitStatus, Stdio};
+use std::{env, io};
+
+/// Opens a file or link with the system default program.
+///
+/// Note that a path like "rustup.rs" could potentially refer to either a file or a website. If you
+/// want to open the website, you should add the "http://" prefix, for example.
+///
+/// Also note that a result of `Ok(())` just means a way of opening the path was found, and no error
+/// occurred as a direct result of opening the path. Errors beyond that point aren't caught. For
+/// example, `Ok(())` would be returned even if a file was opened with a program that can't read the
+/// file, or a dead link was opened in a browser.
+///
+/// ## Platform Implementation Details
+///
+/// - On Windows the `ShellExecuteW` Windows API function is used.
+/// - On Mac the system `open` command is used.
+/// - On Windows Subsystem for Linux (WSL), the system `wslview` from [`wslu`] is used if available,
+/// otherwise the system `xdg-open` is used, if available.
+/// - On non-WSL Linux and other platforms,
+/// the system `xdg-open` script is used if available, otherwise an `xdg-open` script embedded in
+/// this library is used.
+///
+/// [`wslu`]: https://github.com/wslutilities/wslu/
+pub fn open<P>(path: P) -> Result<(), OpenError>
+where
+ P: AsRef<OsStr>,
+{
+ sys::open(path.as_ref())
+}
+
+/// Opens a file or link with the system default program, using the `BROWSER` environment variable
+/// when set.
+///
+/// If the `BROWSER` environment variable is set, the program specified by it is used to open the
+/// path. If not, behavior is identical to [`open()`].
+pub fn open_browser<P>(path: P) -> Result<(), OpenError>
+where
+ P: AsRef<OsStr>,
+{
+ let mut path = path.as_ref();
+ if let Ok(browser_var) = env::var("BROWSER") {
+ let windows_path;
+ if is_wsl() && browser_var.ends_with(".exe") {
+ if let Some(windows_path_2) = wsl_to_windows_path(path) {
+ windows_path = windows_path_2;
+ path = &windows_path;
+ }
+ };
+
+ Command::new(&browser_var)
+ .arg(path)
+ .stdin(Stdio::null())
+ .stdout(Stdio::null())
+ .stderr(Stdio::piped())
+ .spawn()
+ .map_err(OpenError::Io)?;
+
+ Ok(())
+ } else {
+ sys::open(path)
+ }
+}
+
+/// An error type representing the failure to open a path. Possibly returned by the [`open`]
+/// function.
+///
+/// The `ExitStatus` variant will never be returned on Windows.
+#[derive(Debug)]
+pub enum OpenError {
+ /// An IO error occurred.
+ Io(io::Error),
+
+ /// A command exited with a non-zero exit status.
+ ExitStatus {
+ /// A string that identifies the command.
+ cmd: &'static str,
+
+ /// The failed process's exit status.
+ status: ExitStatus,
+
+ /// Anything the process wrote to stderr.
+ stderr: String,
+ },
+}
+
+impl Display for OpenError {
+ fn fmt(&self, f: &mut Formatter<'_>) -> fmt::Result {
+ match self {
+ OpenError::Io(_) => {
+ write!(f, "IO error")?;
+ }
+ OpenError::ExitStatus {
+ cmd,
+ status,
+ stderr,
+ } => {
+ write!(
+ f,
+ "command '{}' did not execute successfully; {}",
+ cmd, status
+ )?;
+
+ let stderr = stderr.trim();
+ if !stderr.is_empty() {
+ write!(f, "\ncommand stderr:\n{}", stderr)?;
+ }
+ }
+ }
+
+ Ok(())
+ }
+}
+
+impl Error for OpenError {
+ fn source(&self) -> Option<&(dyn Error + 'static)> {
+ match self {
+ OpenError::Io(inner) => Some(inner),
+ OpenError::ExitStatus { .. } => None,
+ }
+ }
+}
+
+#[cfg(target_os = "linux")]
+fn is_wsl() -> bool {
+ sys::is_wsl()
+}
+
+#[cfg(not(target_os = "linux"))]
+fn is_wsl() -> bool {
+ false
+}
+
+#[cfg(target_os = "linux")]
+fn wsl_to_windows_path(path: &OsStr) -> Option<OsString> {
+ use bstr::ByteSlice;
+ use std::os::unix::ffi::OsStringExt;
+
+ let output = Command::new("wslpath")
+ .arg("-w")
+ .arg(path)
+ .stdin(Stdio::null())
+ .stdout(Stdio::piped())
+ .stderr(Stdio::null())
+ .output()
+ .ok()?;
+
+ if !output.status.success() {
+ return None;
+ }
+
+ Some(OsString::from_vec(output.stdout.trim_end().to_vec()))
+}
+
+#[cfg(not(target_os = "linux"))]
+fn wsl_to_windows_path(_path: &OsStr) -> Option<OsString> {
+ unreachable!()
+}
+
+#[cfg(not(target_os = "windows"))]
+fn wait_child(child: &mut std::process::Child, cmd_name: &'static str) -> Result<(), OpenError> {
+ use std::io::Read;
+
+ let exit_status = child.wait().map_err(OpenError::Io)?;
+ if exit_status.success() {
+ Ok(())
+ } else {
+ let mut stderr_output = String::new();
+ if let Some(stderr) = child.stderr.as_mut() {
+ stderr.read_to_string(&mut stderr_output).ok();
+ }
+
+ Err(OpenError::ExitStatus {
+ cmd: cmd_name,
+ status: exit_status,
+ stderr: stderr_output,
+ })
+ }
+}
diff --git a/vendor/opener/src/linux_and_more.rs b/vendor/opener/src/linux_and_more.rs
new file mode 100644
index 000000000..87be414b4
--- /dev/null
+++ b/vendor/opener/src/linux_and_more.rs
@@ -0,0 +1,108 @@
+use crate::OpenError;
+use std::ffi::OsStr;
+use std::io::Write;
+use std::process::{Child, Command, Stdio};
+use std::{fs, io};
+
+const XDG_OPEN_SCRIPT: &[u8] = include_bytes!("xdg-open");
+
+pub(crate) fn open(path: &OsStr) -> Result<(), OpenError> {
+ if crate::is_wsl() {
+ wsl_open(path)
+ } else {
+ non_wsl_open(path)
+ }
+}
+
+fn wsl_open(path: &OsStr) -> Result<(), OpenError> {
+ let result = open_with_wslview(path);
+ if let Ok(mut child) = result {
+ return crate::wait_child(&mut child, "wslview");
+ }
+
+ open_with_system_xdg_open(path).map_err(OpenError::Io)?;
+
+ Ok(())
+}
+
+fn non_wsl_open(path: &OsStr) -> Result<(), OpenError> {
+ if open_with_system_xdg_open(path).is_err() {
+ open_with_internal_xdg_open(path)?;
+ }
+
+ Ok(())
+}
+
+fn open_with_wslview(path: &OsStr) -> io::Result<Child> {
+ let converted_path = crate::wsl_to_windows_path(path);
+ let converted_path = converted_path.as_deref();
+ let path = match converted_path {
+ None => path,
+ Some(x) => x,
+ };
+
+ Command::new("wslview")
+ .arg(path)
+ .stdin(Stdio::null())
+ .stdout(Stdio::null())
+ .stderr(Stdio::piped())
+ .spawn()
+}
+
+fn open_with_system_xdg_open(path: &OsStr) -> io::Result<Child> {
+ Command::new("xdg-open")
+ .arg(path)
+ .stdin(Stdio::null())
+ .stdout(Stdio::null())
+ .stderr(Stdio::null())
+ .spawn()
+}
+
+fn open_with_internal_xdg_open(path: &OsStr) -> Result<Child, OpenError> {
+ let mut sh = Command::new("sh")
+ .arg("-s")
+ .arg(path)
+ .stdin(Stdio::piped())
+ .stdout(Stdio::null())
+ .stderr(Stdio::null())
+ .spawn()
+ .map_err(OpenError::Io)?;
+
+ sh.stdin
+ .as_mut()
+ .unwrap()
+ .write_all(XDG_OPEN_SCRIPT)
+ .map_err(OpenError::Io)?;
+
+ Ok(sh)
+}
+
+pub(crate) fn is_wsl() -> bool {
+ if is_docker() {
+ return false;
+ }
+
+ if let Ok(true) = fs::read_to_string("/proc/sys/kernel/osrelease")
+ .map(|osrelease| osrelease.to_ascii_lowercase().contains("microsoft"))
+ {
+ return true;
+ }
+
+ if let Ok(true) = fs::read_to_string("/proc/version")
+ .map(|version| version.to_ascii_lowercase().contains("microsoft"))
+ {
+ return true;
+ }
+
+ false
+}
+
+fn is_docker() -> bool {
+ let has_docker_env = fs::metadata("/.dockerenv").is_ok();
+
+ let has_docker_cgroup = fs::read_to_string("/proc/self/cgroup")
+ .map(|cgroup| cgroup.to_ascii_lowercase().contains("docker"))
+ .unwrap_or(false);
+
+ has_docker_env || has_docker_cgroup
+}
diff --git a/vendor/opener/src/macos.rs b/vendor/opener/src/macos.rs
new file mode 100644
index 000000000..0459ae81f
--- /dev/null
+++ b/vendor/opener/src/macos.rs
@@ -0,0 +1,15 @@
+use crate::OpenError;
+use std::ffi::OsStr;
+use std::process::{Command, Stdio};
+
+pub(crate) fn open(path: &OsStr) -> Result<(), OpenError> {
+ let mut open = Command::new("open")
+ .arg(path)
+ .stdin(Stdio::null())
+ .stdout(Stdio::null())
+ .stderr(Stdio::piped())
+ .spawn()
+ .map_err(OpenError::Io)?;
+
+ crate::wait_child(&mut open, "open")
+}
diff --git a/vendor/opener/src/windows.rs b/vendor/opener/src/windows.rs
new file mode 100644
index 000000000..829bdb0c5
--- /dev/null
+++ b/vendor/opener/src/windows.rs
@@ -0,0 +1,41 @@
+use crate::OpenError;
+use std::ffi::OsStr;
+use std::os::windows::ffi::OsStrExt;
+use std::{io, ptr};
+use winapi::ctypes::c_int;
+use winapi::um::shellapi::ShellExecuteW;
+
+pub(crate) fn open(path: &OsStr) -> Result<(), OpenError> {
+ const SW_SHOW: c_int = 5;
+
+ let path = convert_path(path).map_err(OpenError::Io)?;
+ let operation: Vec<u16> = OsStr::new("open\0").encode_wide().collect();
+ let result = unsafe {
+ ShellExecuteW(
+ ptr::null_mut(),
+ operation.as_ptr(),
+ path.as_ptr(),
+ ptr::null(),
+ ptr::null(),
+ SW_SHOW,
+ )
+ };
+ if result as c_int > 32 {
+ Ok(())
+ } else {
+ Err(OpenError::Io(io::Error::last_os_error()))
+ }
+}
+
+fn convert_path(path: &OsStr) -> io::Result<Vec<u16>> {
+ let mut maybe_result: Vec<u16> = path.encode_wide().collect();
+ if maybe_result.iter().any(|&u| u == 0) {
+ return Err(io::Error::new(
+ io::ErrorKind::InvalidInput,
+ "path contains NUL byte(s)",
+ ));
+ }
+
+ maybe_result.push(0);
+ Ok(maybe_result)
+}
diff --git a/vendor/opener/src/xdg-open b/vendor/opener/src/xdg-open
new file mode 100755
index 000000000..db75e146a
--- /dev/null
+++ b/vendor/opener/src/xdg-open
@@ -0,0 +1,1066 @@
+#!/bin/sh
+#---------------------------------------------
+# xdg-open
+#
+# Utility script to open a URL in the registered default application.
+#
+# Refer to the usage() function below for usage.
+#
+# Copyright 2009-2010, Fathi Boudra <fabo@freedesktop.org>
+# Copyright 2009-2016, Rex Dieter <rdieter@fedoraproject.org>
+# Copyright 2006, Kevin Krammer <kevin.krammer@gmx.at>
+# Copyright 2006, Jeremy White <jwhite@codeweavers.com>
+#
+# LICENSE:
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
+# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+# OTHER DEALINGS IN THE SOFTWARE.
+#
+#---------------------------------------------
+
+manualpage()
+{
+cat << _MANUALPAGE
+Name
+
+ xdg-open -- opens a file or URL in the user's preferred
+ application
+
+Synopsis
+
+ xdg-open { file | URL }
+
+ xdg-open { --help | --manual | --version }
+
+Description
+
+ xdg-open opens a file or URL in the user's preferred
+ application. If a URL is provided the URL will be opened in the
+ user's preferred web browser. If a file is provided the file
+ will be opened in the preferred application for files of that
+ type. xdg-open supports file, ftp, http and https URLs.
+
+ xdg-open is for use inside a desktop session only. It is not
+ recommended to use xdg-open as root.
+
+Options
+
+ --help
+ Show command synopsis.
+
+ --manual
+ Show this manual page.
+
+ --version
+ Show the xdg-utils version information.
+
+Exit Codes
+
+ An exit code of 0 indicates success while a non-zero exit code
+ indicates failure. The following failure codes can be returned:
+
+ 1
+ Error in command line syntax.
+
+ 2
+ One of the files passed on the command line did not
+ exist.
+
+ 3
+ A required tool could not be found.
+
+ 4
+ The action failed.
+
+See Also
+
+ xdg-mime(1), xdg-settings(1), MIME applications associations
+ specification
+
+Examples
+
+xdg-open 'http://www.freedesktop.org/'
+
+ Opens the freedesktop.org website in the user's default
+ browser.
+
+xdg-open /tmp/foobar.png
+
+ Opens the PNG image file /tmp/foobar.png in the user's default
+ image viewing application.
+_MANUALPAGE
+}
+
+usage()
+{
+cat << _USAGE
+ xdg-open -- opens a file or URL in the user's preferred
+ application
+
+Synopsis
+
+ xdg-open { file | URL }
+
+ xdg-open { --help | --manual | --version }
+
+_USAGE
+}
+
+#@xdg-utils-common@
+
+#----------------------------------------------------------------------------
+# Common utility functions included in all XDG wrapper scripts
+#----------------------------------------------------------------------------
+
+DEBUG()
+{
+ [ -z "${XDG_UTILS_DEBUG_LEVEL}" ] && return 0;
+ [ ${XDG_UTILS_DEBUG_LEVEL} -lt $1 ] && return 0;
+ shift
+ echo "$@" >&2
+}
+
+# This handles backslashes but not quote marks.
+first_word()
+{
+ read first rest
+ echo "$first"
+}
+
+#-------------------------------------------------------------
+# map a binary to a .desktop file
+binary_to_desktop_file()
+{
+ search="${XDG_DATA_HOME:-$HOME/.local/share}:${XDG_DATA_DIRS:-/usr/local/share:/usr/share}"
+ binary="`which "$1"`"
+ binary="`readlink -f "$binary"`"
+ base="`basename "$binary"`"
+ IFS=:
+ for dir in $search; do
+ unset IFS
+ [ "$dir" ] || continue
+ [ -d "$dir/applications" ] || [ -d "$dir/applnk" ] || continue
+ for file in "$dir"/applications/*.desktop "$dir"/applications/*/*.desktop "$dir"/applnk/*.desktop "$dir"/applnk/*/*.desktop; do
+ [ -r "$file" ] || continue
+ # Check to make sure it's worth the processing.
+ grep -q "^Exec.*$base" "$file" || continue
+ # Make sure it's a visible desktop file (e.g. not "preferred-web-browser.desktop").
+ grep -Eq "^(NoDisplay|Hidden)=true" "$file" && continue
+ command="`grep -E "^Exec(\[[^]=]*])?=" "$file" | cut -d= -f 2- | first_word`"
+ command="`which "$command"`"
+ if [ x"`readlink -f "$command"`" = x"$binary" ]; then
+ # Fix any double slashes that got added path composition
+ echo "$file" | sed -e 's,//*,/,g'
+ return
+ fi
+ done
+ done
+}
+
+#-------------------------------------------------------------
+# map a .desktop file to a binary
+desktop_file_to_binary()
+{
+ search="${XDG_DATA_HOME:-$HOME/.local/share}:${XDG_DATA_DIRS:-/usr/local/share:/usr/share}"
+ desktop="`basename "$1"`"
+ IFS=:
+ for dir in $search; do
+ unset IFS
+ [ "$dir" ] && [ -d "$dir/applications" ] || [ -d "$dir/applnk" ] || continue
+ # Check if desktop file contains -
+ if [ "${desktop#*-}" != "$desktop" ]; then
+ vendor=${desktop%-*}
+ app=${desktop#*-}
+ if [ -r $dir/applications/$vendor/$app ]; then
+ file_path=$dir/applications/$vendor/$app
+ elif [ -r $dir/applnk/$vendor/$app ]; then
+ file_path=$dir/applnk/$vendor/$app
+ fi
+ fi
+ if test -z "$file_path" ; then
+ for indir in "$dir"/applications/ "$dir"/applications/*/ "$dir"/applnk/ "$dir"/applnk/*/; do
+ file="$indir/$desktop"
+ if [ -r "$file" ]; then
+ file_path=$file
+ break
+ fi
+ done
+ fi
+ if [ -r "$file_path" ]; then
+ # Remove any arguments (%F, %f, %U, %u, etc.).
+ command="`grep -E "^Exec(\[[^]=]*])?=" "$file_path" | cut -d= -f 2- | first_word`"
+ command="`which "$command"`"
+ readlink -f "$command"
+ return
+ fi
+ done
+}
+
+#-------------------------------------------------------------
+# Exit script on successfully completing the desired operation
+
+exit_success()
+{
+ if [ $# -gt 0 ]; then
+ echo "$@"
+ echo
+ fi
+
+ exit 0
+}
+
+
+#-----------------------------------------
+# Exit script on malformed arguments, not enough arguments
+# or missing required option.
+# prints usage information
+
+exit_failure_syntax()
+{
+ if [ $# -gt 0 ]; then
+ echo "xdg-open: $@" >&2
+ echo "Try 'xdg-open --help' for more information." >&2
+ else
+ usage
+ echo "Use 'man xdg-open' or 'xdg-open --manual' for additional info."
+ fi
+
+ exit 1
+}
+
+#-------------------------------------------------------------
+# Exit script on missing file specified on command line
+
+exit_failure_file_missing()
+{
+ if [ $# -gt 0 ]; then
+ echo "xdg-open: $@" >&2
+ fi
+
+ exit 2
+}
+
+#-------------------------------------------------------------
+# Exit script on failure to locate necessary tool applications
+
+exit_failure_operation_impossible()
+{
+ if [ $# -gt 0 ]; then
+ echo "xdg-open: $@" >&2
+ fi
+
+ exit 3
+}
+
+#-------------------------------------------------------------
+# Exit script on failure returned by a tool application
+
+exit_failure_operation_failed()
+{
+ if [ $# -gt 0 ]; then
+ echo "xdg-open: $@" >&2
+ fi
+
+ exit 4
+}
+
+#------------------------------------------------------------
+# Exit script on insufficient permission to read a specified file
+
+exit_failure_file_permission_read()
+{
+ if [ $# -gt 0 ]; then
+ echo "xdg-open: $@" >&2
+ fi
+
+ exit 5
+}
+
+#------------------------------------------------------------
+# Exit script on insufficient permission to write a specified file
+
+exit_failure_file_permission_write()
+{
+ if [ $# -gt 0 ]; then
+ echo "xdg-open: $@" >&2
+ fi
+
+ exit 6
+}
+
+check_input_file()
+{
+ if [ ! -e "$1" ]; then
+ exit_failure_file_missing "file '$1' does not exist"
+ fi
+ if [ ! -r "$1" ]; then
+ exit_failure_file_permission_read "no permission to read file '$1'"
+ fi
+}
+
+check_vendor_prefix()
+{
+ file_label="$2"
+ [ -n "$file_label" ] || file_label="filename"
+ file=`basename "$1"`
+ case "$file" in
+ [[:alpha:]]*-*)
+ return
+ ;;
+ esac
+
+ echo "xdg-open: $file_label '$file' does not have a proper vendor prefix" >&2
+ echo 'A vendor prefix consists of alpha characters ([a-zA-Z]) and is terminated' >&2
+ echo 'with a dash ("-"). An example '"$file_label"' is '"'example-$file'" >&2
+ echo "Use --novendor to override or 'xdg-open --manual' for additional info." >&2
+ exit 1
+}
+
+check_output_file()
+{
+ # if the file exists, check if it is writeable
+ # if it does not exists, check if we are allowed to write on the directory
+ if [ -e "$1" ]; then
+ if [ ! -w "$1" ]; then
+ exit_failure_file_permission_write "no permission to write to file '$1'"
+ fi
+ else
+ DIR=`dirname "$1"`
+ if [ ! -w "$DIR" ] || [ ! -x "$DIR" ]; then
+ exit_failure_file_permission_write "no permission to create file '$1'"
+ fi
+ fi
+}
+
+#----------------------------------------
+# Checks for shared commands, e.g. --help
+
+check_common_commands()
+{
+ while [ $# -gt 0 ] ; do
+ parm="$1"
+ shift
+
+ case "$parm" in
+ --help)
+ usage
+ echo "Use 'man xdg-open' or 'xdg-open --manual' for additional info."
+ exit_success
+ ;;
+
+ --manual)
+ manualpage
+ exit_success
+ ;;
+
+ --version)
+ echo "xdg-open 1.1.3+"
+ exit_success
+ ;;
+ esac
+ done
+}
+
+check_common_commands "$@"
+
+[ -z "${XDG_UTILS_DEBUG_LEVEL}" ] && unset XDG_UTILS_DEBUG_LEVEL;
+if [ ${XDG_UTILS_DEBUG_LEVEL-0} -lt 1 ]; then
+ # Be silent
+ xdg_redirect_output=" > /dev/null 2> /dev/null"
+else
+ # All output to stderr
+ xdg_redirect_output=" >&2"
+fi
+
+#--------------------------------------
+# Checks for known desktop environments
+# set variable DE to the desktop environments name, lowercase
+
+detectDE()
+{
+ # see https://bugs.freedesktop.org/show_bug.cgi?id=34164
+ unset GREP_OPTIONS
+
+ if [ -n "${XDG_CURRENT_DESKTOP}" ]; then
+ case "${XDG_CURRENT_DESKTOP}" in
+ # only recently added to menu-spec, pre-spec X- still in use
+ Cinnamon|X-Cinnamon)
+ DE=cinnamon;
+ ;;
+ ENLIGHTENMENT)
+ DE=enlightenment;
+ ;;
+ # GNOME, GNOME-Classic:GNOME, or GNOME-Flashback:GNOME
+ GNOME*)
+ DE=gnome;
+ ;;
+ KDE)
+ DE=kde;
+ ;;
+ DEEPIN|Deepin|deepin)
+ DE=deepin;
+ ;;
+ LXDE)
+ DE=lxde;
+ ;;
+ LXQt)
+ DE=lxqt;
+ ;;
+ MATE)
+ DE=mate;
+ ;;
+ XFCE)
+ DE=xfce
+ ;;
+ X-Generic)
+ DE=generic
+ ;;
+ esac
+ fi
+
+ if [ x"$DE" = x"" ]; then
+ # classic fallbacks
+ if [ x"$KDE_FULL_SESSION" != x"" ]; then DE=kde;
+ elif [ x"$GNOME_DESKTOP_SESSION_ID" != x"" ]; then DE=gnome;
+ elif [ x"$MATE_DESKTOP_SESSION_ID" != x"" ]; then DE=mate;
+ elif `dbus-send --print-reply --dest=org.freedesktop.DBus /org/freedesktop/DBus org.freedesktop.DBus.GetNameOwner string:org.gnome.SessionManager > /dev/null 2>&1` ; then DE=gnome;
+ elif xprop -root _DT_SAVE_MODE 2> /dev/null | grep ' = \"xfce4\"$' >/dev/null 2>&1; then DE=xfce;
+ elif xprop -root 2> /dev/null | grep -i '^xfce_desktop_window' >/dev/null 2>&1; then DE=xfce
+ elif echo $DESKTOP | grep -q '^Enlightenment'; then DE=enlightenment;
+ elif [ x"$LXQT_SESSION_CONFIG" != x"" ]; then DE=lxqt;
+ fi
+ fi
+
+ if [ x"$DE" = x"" ]; then
+ # fallback to checking $DESKTOP_SESSION
+ case "$DESKTOP_SESSION" in
+ gnome)
+ DE=gnome;
+ ;;
+ LXDE|Lubuntu)
+ DE=lxde;
+ ;;
+ MATE)
+ DE=mate;
+ ;;
+ xfce|xfce4|'Xfce Session')
+ DE=xfce;
+ ;;
+ esac
+ fi
+
+ if [ x"$DE" = x"" ]; then
+ # fallback to uname output for other platforms
+ case "$(uname 2>/dev/null)" in
+ CYGWIN*)
+ DE=cygwin;
+ ;;
+ Darwin)
+ DE=darwin;
+ ;;
+ esac
+ fi
+
+ if [ x"$DE" = x"gnome" ]; then
+ # gnome-default-applications-properties is only available in GNOME 2.x
+ # but not in GNOME 3.x
+ which gnome-default-applications-properties > /dev/null 2>&1 || DE="gnome3"
+ fi
+
+ if [ -f "$XDG_RUNTIME_DIR/flatpak-info" ]; then
+ DE="flatpak"
+ fi
+}
+
+#----------------------------------------------------------------------------
+# kfmclient exec/openURL can give bogus exit value in KDE <= 3.5.4
+# It also always returns 1 in KDE 3.4 and earlier
+# Simply return 0 in such case
+
+kfmclient_fix_exit_code()
+{
+ version=`LC_ALL=C.UTF-8 kde-config --version 2>/dev/null | grep '^KDE'`
+ major=`echo $version | sed 's/KDE.*: \([0-9]\).*/\1/'`
+ minor=`echo $version | sed 's/KDE.*: [0-9]*\.\([0-9]\).*/\1/'`
+ release=`echo $version | sed 's/KDE.*: [0-9]*\.[0-9]*\.\([0-9]\).*/\1/'`
+ test "$major" -gt 3 && return $1
+ test "$minor" -gt 5 && return $1
+ test "$release" -gt 4 && return $1
+ return 0
+}
+
+#----------------------------------------------------------------------------
+# Returns true if there is a graphical display attached.
+
+has_display()
+{
+ if [ -n "$DISPLAY" ] || [ -n "$WAYLAND_DISPLAY" ]; then
+ return 0
+ else
+ return 1
+ fi
+}
+
+# This handles backslashes but not quote marks.
+last_word()
+{
+ read first rest
+ echo "$rest"
+}
+
+# Get the value of a key in a desktop file's Desktop Entry group.
+# Example: Use get_key foo.desktop Exec
+# to get the values of the Exec= key for the Desktop Entry group.
+get_key()
+{
+ local file="${1}"
+ local key="${2}"
+ local desktop_entry=""
+
+ IFS_="${IFS}"
+ IFS=""
+ while read line
+ do
+ case "$line" in
+ "[Desktop Entry]")
+ desktop_entry="y"
+ ;;
+ # Reset match flag for other groups
+ "["*)
+ desktop_entry=""
+ ;;
+ "${key}="*)
+ # Only match Desktop Entry group
+ if [ -n "${desktop_entry}" ]
+ then
+ echo "${line}" | cut -d= -f 2-
+ fi
+ esac
+ done < "${file}"
+ IFS="${IFS_}"
+}
+
+# Returns true if argument is a file:// URL or path
+is_file_url_or_path()
+{
+ if echo "$1" | grep -q '^file://' \
+ || ! echo "$1" | egrep -q '^[[:alpha:]][[:alpha:][:digit:]+\.\-]*:'; then
+ return 0
+ else
+ return 1
+ fi
+}
+
+# If argument is a file URL, convert it to a (percent-decoded) path.
+# If not, leave it as it is.
+file_url_to_path()
+{
+ local file="$1"
+ if echo "$file" | grep -q '^file://\(localhost\)\?/'; then
+ file=${file#file://localhost}
+ file=${file#file://}
+ file=${file%%#*}
+ file=$(echo "$file" | sed -r 's/\?.*$//')
+ local printf=printf
+ if [ -x /usr/bin/printf ]; then
+ printf=/usr/bin/printf
+ fi
+ file=$($printf "$(echo "$file" | sed -e 's@%\([a-f0-9A-F]\{2\}\)@\\x\1@g')")
+ fi
+ echo "$file"
+}
+
+open_cygwin()
+{
+ cygstart "$1"
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_darwin()
+{
+ open "$1"
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_kde()
+{
+ if [ -n "${KDE_SESSION_VERSION}" ]; then
+ case "${KDE_SESSION_VERSION}" in
+ 4)
+ kde-open "$1"
+ ;;
+ 5)
+ kde-open${KDE_SESSION_VERSION} "$1"
+ ;;
+ esac
+ else
+ kfmclient exec "$1"
+ kfmclient_fix_exit_code $?
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_deepin()
+{
+ if dde-open -version >/dev/null 2>&1; then
+ dde-open "$1"
+ else
+ open_generic "$1"
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_gnome3()
+{
+ if gio help open 2>/dev/null 1>&2; then
+ gio open "$1"
+ elif gvfs-open --help 2>/dev/null 1>&2; then
+ gvfs-open "$1"
+ else
+ open_generic "$1"
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_gnome()
+{
+ if gio help open 2>/dev/null 1>&2; then
+ gio open "$1"
+ elif gvfs-open --help 2>/dev/null 1>&2; then
+ gvfs-open "$1"
+ elif gnome-open --help 2>/dev/null 1>&2; then
+ gnome-open "$1"
+ else
+ open_generic "$1"
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_mate()
+{
+ if gio help open 2>/dev/null 1>&2; then
+ gio open "$1"
+ elif gvfs-open --help 2>/dev/null 1>&2; then
+ gvfs-open "$1"
+ elif mate-open --help 2>/dev/null 1>&2; then
+ mate-open "$1"
+ else
+ open_generic "$1"
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_xfce()
+{
+ if exo-open --help 2>/dev/null 1>&2; then
+ exo-open "$1"
+ elif gio help open 2>/dev/null 1>&2; then
+ gio open "$1"
+ elif gvfs-open --help 2>/dev/null 1>&2; then
+ gvfs-open "$1"
+ else
+ open_generic "$1"
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_enlightenment()
+{
+ if enlightenment_open --help 2>/dev/null 1>&2; then
+ enlightenment_open "$1"
+ else
+ open_generic "$1"
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_flatpak()
+{
+ gdbus call --session \
+ --dest org.freedesktop.portal.Desktop \
+ --object-path /org/freedesktop/portal/desktop \
+ --method org.freedesktop.portal.OpenURI.OpenURI \
+ "" "$1" {}
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+#-----------------------------------------
+# Recursively search .desktop file
+
+search_desktop_file()
+{
+ local default="$1"
+ local dir="$2"
+ local target="$3"
+
+ local file=""
+ # look for both vendor-app.desktop, vendor/app.desktop
+ if [ -r "$dir/$default" ]; then
+ file="$dir/$default"
+ elif [ -r "$dir/`echo $default | sed -e 's|-|/|'`" ]; then
+ file="$dir/`echo $default | sed -e 's|-|/|'`"
+ fi
+
+ if [ -r "$file" ] ; then
+ command="$(get_key "${file}" "Exec" | first_word)"
+ command_exec=`which $command 2>/dev/null`
+ icon="$(get_key "${file}" "Icon")"
+ # FIXME: Actually LC_MESSAGES should be used as described in
+ # http://standards.freedesktop.org/desktop-entry-spec/latest/ar01s04.html
+ localised_name="$(get_key "${file}" "Name")"
+ set -- $(get_key "${file}" "Exec" | last_word)
+ # We need to replace any occurrence of "%f", "%F" and
+ # the like by the target file. We examine each
+ # argument and append the modified argument to the
+ # end then shift.
+ local args=$#
+ local replaced=0
+ while [ $args -gt 0 ]; do
+ case $1 in
+ %[c])
+ replaced=1
+ arg="${localised_name}"
+ shift
+ set -- "$@" "$arg"
+ ;;
+ %[fFuU])
+ replaced=1
+ arg="$target"
+ shift
+ set -- "$@" "$arg"
+ ;;
+ %[i])
+ replaced=1
+ shift
+ set -- "$@" "--icon" "$icon"
+ ;;
+ *)
+ arg="$1"
+ shift
+ set -- "$@" "$arg"
+ ;;
+ esac
+ args=$(( $args - 1 ))
+ done
+ [ $replaced -eq 1 ] || set -- "$@" "$target"
+ "$command_exec" "$@"
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ fi
+ fi
+
+ for d in "$dir/"*/; do
+ [ -d "$d" ] && search_desktop_file "$default" "$d" "$target"
+ done
+}
+
+
+open_generic_xdg_mime()
+{
+ filetype="$2"
+ default=`xdg-mime query default "$filetype"`
+ if [ -n "$default" ] ; then
+ xdg_user_dir="$XDG_DATA_HOME"
+ [ -n "$xdg_user_dir" ] || xdg_user_dir="$HOME/.local/share"
+
+ xdg_system_dirs="$XDG_DATA_DIRS"
+ [ -n "$xdg_system_dirs" ] || xdg_system_dirs=/usr/local/share/:/usr/share/
+
+DEBUG 3 "$xdg_user_dir:$xdg_system_dirs"
+ for x in `echo "$xdg_user_dir:$xdg_system_dirs" | sed 's/:/ /g'`; do
+ search_desktop_file "$default" "$x/applications/" "$1"
+ done
+ fi
+}
+
+open_generic_xdg_file_mime()
+{
+ filetype=`xdg-mime query filetype "$1" | sed "s/;.*//"`
+ open_generic_xdg_mime "$1" "$filetype"
+}
+
+open_generic_xdg_x_scheme_handler()
+{
+ scheme="`echo $1 | sed -n 's/\(^[[:alnum:]+\.-]*\):.*$/\1/p'`"
+ if [ -n $scheme ]; then
+ filetype="x-scheme-handler/$scheme"
+ open_generic_xdg_mime "$1" "$filetype"
+ fi
+}
+
+has_single_argument()
+{
+ test $# = 1
+}
+
+open_envvar()
+{
+ local oldifs="$IFS"
+ local browser browser_with_arg
+
+ IFS=":"
+ for browser in $BROWSER; do
+ IFS="$oldifs"
+
+ if [ -z "$browser" ]; then
+ continue
+ fi
+
+ if echo "$browser" | grep -q %s; then
+ # Avoid argument injection.
+ # See https://bugs.freedesktop.org/show_bug.cgi?id=103807
+ # URIs don't have IFS characters spaces anyway.
+ has_single_argument $1 && $(printf "$browser" "$1")
+ else
+ $browser "$1"
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ fi
+ done
+}
+
+open_generic()
+{
+ if is_file_url_or_path "$1"; then
+ local file="$(file_url_to_path "$1")"
+
+ check_input_file "$file"
+
+ if has_display; then
+ filetype=`xdg-mime query filetype "$file" | sed "s/;.*//"`
+ open_generic_xdg_mime "$file" "$filetype"
+ fi
+
+ if which run-mailcap 2>/dev/null 1>&2; then
+ run-mailcap --action=view "$file"
+ if [ $? -eq 0 ]; then
+ exit_success
+ fi
+ fi
+
+ if has_display && mimeopen -v 2>/dev/null 1>&2; then
+ mimeopen -L -n "$file"
+ if [ $? -eq 0 ]; then
+ exit_success
+ fi
+ fi
+ fi
+
+ if has_display; then
+ open_generic_xdg_x_scheme_handler "$1"
+ fi
+
+ if [ -n "$BROWSER" ]; then
+ open_envvar "$1"
+ fi
+
+ # if BROWSER variable is not set, check some well known browsers instead
+ if [ x"$BROWSER" = x"" ]; then
+ BROWSER=www-browser:links2:elinks:links:lynx:w3m
+ if has_display; then
+ BROWSER=x-www-browser:firefox:iceweasel:seamonkey:mozilla:epiphany:konqueror:chromium:chromium-browser:google-chrome:$BROWSER
+ fi
+ fi
+
+ open_envvar "$1"
+
+ exit_failure_operation_impossible "no method available for opening '$1'"
+}
+
+open_lxde()
+{
+
+ # pcmanfm only knows how to handle file:// urls and filepaths, it seems.
+ if pcmanfm --help >/dev/null 2>&1 && is_file_url_or_path "$1"; then
+ local file="$(file_url_to_path "$1")"
+
+ # handle relative paths
+ if ! echo "$file" | grep -q ^/; then
+ file="$(pwd)/$file"
+ fi
+
+ pcmanfm "$file"
+ else
+ open_generic "$1"
+ fi
+
+ if [ $? -eq 0 ]; then
+ exit_success
+ else
+ exit_failure_operation_failed
+ fi
+}
+
+open_lxqt()
+{
+ open_generic "$1"
+}
+
+[ x"$1" != x"" ] || exit_failure_syntax
+
+url=
+while [ $# -gt 0 ] ; do
+ parm="$1"
+ shift
+
+ case "$parm" in
+ -*)
+ exit_failure_syntax "unexpected option '$parm'"
+ ;;
+
+ *)
+ if [ -n "$url" ] ; then
+ exit_failure_syntax "unexpected argument '$parm'"
+ fi
+ url="$parm"
+ ;;
+ esac
+done
+
+if [ -z "${url}" ] ; then
+ exit_failure_syntax "file or URL argument missing"
+fi
+
+detectDE
+
+if [ x"$DE" = x"" ]; then
+ DE=generic
+fi
+
+DEBUG 2 "Selected DE $DE"
+
+# sanitize BROWSER (avoid calling ourselves in particular)
+case "${BROWSER}" in
+ *:"xdg-open"|"xdg-open":*)
+ BROWSER=$(echo $BROWSER | sed -e 's|:xdg-open||g' -e 's|xdg-open:||g')
+ ;;
+ "xdg-open")
+ BROWSER=
+ ;;
+esac
+
+case "$DE" in
+ kde)
+ open_kde "$url"
+ ;;
+
+ deepin)
+ open_deepin "$url"
+ ;;
+
+ gnome3|cinnamon)
+ open_gnome3 "$url"
+ ;;
+
+ gnome)
+ open_gnome "$url"
+ ;;
+
+ mate)
+ open_mate "$url"
+ ;;
+
+ xfce)
+ open_xfce "$url"
+ ;;
+
+ lxde)
+ open_lxde "$url"
+ ;;
+
+ lxqt)
+ open_lxqt "$url"
+ ;;
+
+ enlightenment)
+ open_enlightenment "$url"
+ ;;
+
+ cygwin)
+ open_cygwin "$url"
+ ;;
+
+ darwin)
+ open_darwin "$url"
+ ;;
+
+ flatpak)
+ open_flatpak "$url"
+ ;;
+
+ generic)
+ open_generic "$url"
+ ;;
+
+ *)
+ exit_failure_operation_impossible "no method available for opening '$url'"
+ ;;
+esac
diff --git a/vendor/opener/tests/version-numbers.rs b/vendor/opener/tests/version-numbers.rs
new file mode 100644
index 000000000..cfcb2586f
--- /dev/null
+++ b/vendor/opener/tests/version-numbers.rs
@@ -0,0 +1,4 @@
+#[test]
+fn test_html_root_url() {
+ version_sync::assert_html_root_url_updated!("src/lib.rs");
+}